\documentclass[a4paper]{article}
\usepackage[left=2.2cm,right=2.2cm,top=2.5cm,bottom=2.5cm]{geometry} % page settings
\usepackage{amsmath}
\usepackage{amssymb}
%\usepackage{amsthm}
%\usepackage{etoolbox}
\usepackage[english]{babel}
\usepackage[utf8]{inputenc}
%\usepackage{framed}
\usepackage{fancyhdr}
%\usepackage{tikz}
\usepackage{graphicx}
\usepackage{subcaption}
\usepackage{hyperref}

\setlength{\parskip}{\medskipamount}
\setlength{\parindent}{0pt}

\pagestyle{fancy}
\lhead{
    \begin{tabular}{ll}
      Lab Course Deep Learning \\
      Winter term 2017/18
  \end{tabular}
}
\chead{}
\rhead{
  \begin{tabular}{ll}
    Fabian Glöckle \\
    18/12/2017
  \end{tabular}
}
\lfoot{}
\cfoot{}
\rfoot{} 


\begin{document}

\title{Deep Learning Lab Course Report 5}
\author{Fabian Glöckle}
\date{\today}
% \maketitle

\subsection*{Hyperparameter optimization and Bayesian optimization}

In this exercise , we used random search and a bayesian optimization
framework for hyperparameter optimization. The code can be found on my
gitlab
repo \footnote{\url{https://gitlab.com/fabian.g/deep-learning/tree/master}}.

\subsubsection*{Problem}

We want to implement a network for the CIFAR10 image classification
task. The network shall consist of three convolutional layers. The
numbers of filters per layer, the batch size and learning rate are
thus hyperparameters of the architecture we want to optimize using the
validation set. We use the lower and upper bounds of the parameters as
given in the exercise sheet and run random seach and bayesian
optimization within these bounds. The former samples hyperparameters
logarithmically uniformly and estimates the validation error using a
surrogate model. The latter is done using the RoBO framework for
Bayesian optimization.

\subsubsection*{Results}

\begin{figure}[h!] 
\includegraphics[width=\textwidth]{./ho_optimization/trajectories.png} 
\caption{Validation error by optimization iteration. Shown is the
  average of the validation error for the incumbent hyperparameter
  configuration. The chart compares random search and Bayesian
  optimization.}
\label{fig1}
\end{figure}

Figure 1 shows the validation errors of the two optimization processes
by iteration. The respective incumbent (so far best) parameter
configurations of random search or Bayesian optimization respectively
are compared. The values are averaged over 10 runs.

From iteration 10 to 12 on, Bayesian optimization takes the lead over
random search and ``converges'' to a validation error slightly lower
than random search. However, with 1 to 2 percent, the difference is
still small compared to the total validation error of 15 to 17
percent.

\subsubsection*{Runtime comparison}

\begin{figure}[h!] 
\includegraphics[width=\textwidth]{./ho_optimization/runtimes.png} 
\caption{Cumulated runtime by iteration of random search and Bayesian
  optimization, respectively.}
\label{fig2}
\end{figure}

Figure 2 shows the cumulated runtime of the two optimization
algorithms, using the provided runtime model. 

Especially in the later phases, Bayesian optimization tends to have
slightly longer evaluation times. This could hint at the tendency that
the algorithm prefers to evaluate configurations with many parameters
because they have shown better results in the past.

\end{document}
